package com.mortals.xhx.common.utils;

import com.documents4j.api.DocumentType;
import com.documents4j.api.IConverter;
import com.documents4j.job.LocalConverter;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import java.io.*;

public class PdfUtil {
    protected static Log log = LogFactory.getLog(PdfUtil.class);
    /**
     　　* word转pdf
     * @param wordFilePath word文件路径
     * @param pdfFilePath  pdf文件路径
     * @return 成功或失败
     */
    public static boolean docxToPdf(String wordFilePath, String pdfFilePath) throws Exception {
        boolean result = false;
        InputStream inputStream = null;
        OutputStream outputStream = null;
        File inputFile = new File(wordFilePath);
        File outputFile = new File(pdfFilePath);
        try {
            inputStream = new FileInputStream(inputFile);
            outputStream = new FileOutputStream(outputFile);
            //IConverter converter = LocalConverter.builder().build();
            IConverter converter = SingletonLocalConverter.getInstance().getConverter();
            converter.convert(inputStream).as(DocumentType.DOCX).to(outputStream).as(DocumentType.PDF).execute();

            outputStream.close();
            inputStream.close();

            result = true;
        } catch (Exception e) {
            log.error("[documents4J] word转pdf失败:",e);
            e.printStackTrace();
        }finally {
            if (outputStream != null) {
                outputStream.close();
            }
            if (inputStream != null) {
                inputStream.close();
            }
        }

        return result;
    }

    public static void main(String[] args) {
        String filepath= "D:\\mortals\\app\\data\\test\\12a.docx";
        String outpath= "D:\\mortals\\app\\data\\test\\12aa.pdf";
        try{
            long old = System.currentTimeMillis();
            docxToPdf(filepath, outpath);
            long now = System.currentTimeMillis();
            System.out.println("pdf转换成功，共耗时：" + ((now - old) / 1000.0) + "秒"); // 转化用时
        }catch(Exception e) {
            e.printStackTrace();
        }
    }

}

